#ifndef uchar
#define uchar 	unsigned char
#endif
#ifndef ushort
#define ushort 	unsigned short
#endif
#ifndef NULL
#define NULL 	0
#endif
typedef char string8x11[];
//    --------
//   D0-D7
#define LCD_DATA	PORTC
// DDR   D0-D7
#define DLCD_DATA	DDRC
// PINS   D0-D7
#define PLCD_DATA	PINC

//        
//  -  6   D  G
#define CE_b PORTD_Bit7
#define RD_b PORTD_Bit6
#define WR_b PORTD_Bit5
#define RV_b PORTG_Bit2
#define RST_b PORTG_Bit1
#define CD_b PORTG_Bit0


//   
#define LCD_CTRL	PORTA
// DDR  
#define DLCD_CTRL	DDRA




//      
#define BLCD_CD		4
#define BLCD_READ	6
#define BLCD_WRITE	7
#define BLCD_RESET	3
#define BLCD_CE		5

#define B_WRITE	        0x80
#define B_READ	        0x40
#define B_CE		0x20
#define B_CD		0x10
#define B_RESET	        0x08
#define B_FS	        0x04
#define B_RV	        0x02

#define LCD_MASK	1<<BLCD_CD | 1<<BLCD_READ | 1<<BLCD_WRITE | 1<<BLCD_RESET | 1<<BLCD_CE

// Screen size
#define LCD_WIDTH		(unsigned char)240
#define LCD_HEIGHT		(unsigned char)128

// FONTS
//#define FONT_SMALL		(unsigned char)0
//#define FONT_MEDIUM		(unsigned char)1

// Draw modes
#define DMODE_FILL		(unsigned char)0
#define DMODE_INV		(unsigned char)1
#define DMODE_AND		(unsigned char)2
#define DMODE_OR		(unsigned char)3
#define DMODE_XOR		(unsigned char)4

// Text flags (graphics)
//#define GTXT_CARR		(unsigned char)0x08
//#define GTXT_RIGHT		(unsigned char)0x10

//****************************   *******************************
void WR_cmd(uchar c);
void WR_dt(uchar c);
//  ,   (  ),  , 
//   - EXOR mode, Display_Off, 1-line cursor.
void Init_LCD(void);
void GClrSCR(void);
//   LCD
uchar LCD_Check();

//   
void LCD_WaitData();
void LCD_WaitCommand();
//void LCD_WaitAutoRead();
void LCD_WaitAutoWrite();




//      LCD
void LCD_WriteCommand(uchar c);
//   1-   LCD
//void LCD_WriteCommand1(uchar c, uchar d1);
//       LCD
void LCD_WriteCommand2(uchar c, uchar d1, uchar d2);

//    (  t   g)
//void LCD_SetScreenMode(bool t, bool g);

//  1-    LCD
uchar LCD_ReadData();



//       
void LCD_SetPointerPos(ushort x);

//**************************************************************************
// ,      (6963)

//    
//void LCD_ClearText();


//**************************************************************************
// ,      (6963)

//    
void LCD_ClearGraphic();

//   flash     n_displ
//void dyspl_gr(uchar n_displ);

//        ,    x, y.
//     - \n.       ,
//        .
//        ,   
//  .  x  y  255,    
// .
// mode:      ,   .
//       : DMODE_FILL -            0
//              DMODE_INV -    1
//              DMODE_AND -            2
//              DMODE_OR -           3
//              DMODE_XOR -       4
//   - DMODE_FILL.      .
//void LCD_DrawChar(char s, uchar x, uchar y, uchar mode);

//       
// x=0 y=0 -    ,  = 0...29; y = 0-127
void Set_XY(uchar x,uchar y);


// 1   8x11      X  Y
// x = 0...29; y = 0-127 (c c "")
//        
void PutChar_lt(uchar c,uchar x,uchar y);

// 1   16x24      X  Y
// x = 0...29; y = 0-127 (c c "")
//        
void PutChar_big(uchar c,uchar x,uchar y);

// 1  16x16      X  Y
// x = 0...29; y = 0-127 (c c "")
//        
void PutChar_img(uchar c,uchar x,uchar y);

//  str  811    X  Y
// x = 0...29; y = 0-127 (c c "")
//     
//void write_str(char str[30],uchar x,uchar y);
void write_str(const char *s,uchar x,uchar y);
/*

  write_str("string8x11 str",0, 12);
  write_str(string_2,0, 12);
string_2[]  
const char string_2[]=  {"   "};
*/
void write_str_f(char __flash *s,uchar x,uchar y);





