/************************************************
*    LCD   T6963      *
* 		PTR-02V (-1008, HXT.pcb      *
************************************************/

#include <iom64.h>
#include <inavr.h>
#include <stdbool.h>
#include "lcd_lib.h"

#include "my_fonts.h"
//#include "my_string.h"
//-----------------------------------------------

#define DELAY_LCD	3

ushort const vLCD_GH = 0x0000;  //Graphics home
ushort const vLCD_GA = 30;//Graphics area 30*8=240


//-----------------------------------------------
bool lcd_inited = false;
uchar lcd_res;

//----------------------------------------------------------------------------------
void GClrSCR(void)
{
int i,j;

 WR_dt(0x00);         // CURSOR WRITE COMMAND
 WR_dt(0x00);    // Cursor position low byte
 WR_cmd(0x24);    // Cursor position high byte

j = (30*128);
for (i=0;i<j;i++)
   {WR_dt(0x00);  WR_cmd(0xC0);}
}

void Delay_2ms(void)
{
int i,j;
for (i=0;i<330;i++)
   { for (j=1;j<20;j++) ;}
}
//----------------------------------------------------------------------------------






void W_ready(void)
{
  DDRC=0x00;                //  
  PORTC=0xff;               // pull up
//  PORTA &= ~(B_READ);
  RD_b=0;
//  PORTA &= ~(B_CE);
  CE_b=0;
  __delay_cycles(4);
  while ((PINC&0x01)!=0x01) ; // "1"
  while ((PINC&0x02)!=0x02) ;
//  PORTA |= (B_CE);
  CE_b=1;
//  PORTA |= (B_READ);
  RD_b=1;
  DDRC=0xff;
}



//----------------------------------------------------------------------------------
void Init_LCD(void)
{

//uchar i;
//  DDRA=0xFB;  //????????????
  DDRC=0xff;
//  PORTA &= ~(B_FS); //8x8 font
//  PORTA &= ~(B_RV); // 0 - normal(black on white); 1 - invert.
  RV_b=0;
//  PORTA &= ~(B_RESET);
  RST_b=0;
  __delay_cycles(20);
//  PORTA |= (B_RESET);
  RST_b=1;
/*
  for (i=0;i<20;i++)
   {
   Delay_2ms();
   }
*/
//  WR_dt (0x00);  WR_dt (0x0f);  WR_cmd(0x40);
//  WR_dt (0x1e);  WR_dt (0x00);  WR_cmd(0x41);
  WR_dt (0x00);  WR_dt (0x00);  WR_cmd(0x42);
  WR_dt (0x1e);  WR_dt (0x00);  WR_cmd(0x43);
  WR_cmd(0x81);  //EXOR mode
  WR_dt (0x00);  WR_dt (0x00);  WR_cmd(0x24); //ADP - 0000

//  WR_cmd(0xa7);
//  WR_dt (0x00);  WR_dt (0x0f);  WR_cmd(0x21);

  WR_cmd(0x98); // Graphics only

 GClrSCR();

}
//----------------------------------------------------------------------------------
void WR_cmd(uchar c)
{
  W_ready();
  LCD_DATA = c;
//  PORTA |= (B_CD); // BLCD_CD -> 1
  CD_b=1;
//  PORTA &= ~(B_WRITE);
  WR_b=0;
//  PORTA &= ~(B_CE);
  CE_b=0;
//  PORTA |= (B_CE);
  CE_b=1;
//    __delay_cycles(DELAY_LCD);

//  PORTA |= (B_WRITE);
  WR_b=1;
//  PORTA |= (B_CD); // BLCD_CD -> 1
  CD_b=1;
//    __delay_cycles(DELAY_LCD);
  ;
}
//----------------------------------------------------------------------------------
void WR_dt(uchar c)
{
  W_ready();
  LCD_DATA = c;
//  PORTA &= ~(B_CD); // BLCD_CD -> 0
  CD_b=0;
//  PORTA &= ~(B_WRITE);
  WR_b=0;
//  PORTA &= ~(B_CE);
  CE_b=0;
//  PORTA |= (B_CE);
  CE_b=1;
//    __delay_cycles(DELAY_LCD);

//  PORTA |= (B_WRITE);
  WR_b=1;
//  PORTA |= (B_CD); // BLCD_CD -> 1
  CD_b=1;
//    __delay_cycles(DELAY_LCD);
  ;
}

//----------------------------------------------------------------------------------
// 1   8x11      X  Y
// x = 0...29; y = 0-127 (c c "")
//        

void PutChar_lt(uchar c,uchar x,uchar y)
{
  uchar j,b;
  ushort addr;

  for (j=0;j<11;j++)
  {
    addr=vLCD_GH+(y+j)*vLCD_GA+x;
    b= char_lt[c][j];
    WR_dt(addr&0xFF); WR_dt(addr>>8); WR_cmd(0x24);
    WR_dt(b); WR_cmd(0xc4);
  }
;
}


//----------------------------------------------------------------------------------

// 1   16x24      X  Y
// x = 0...29; y = 0-127 (c c "")
//        
void PutChar_big(uchar c,uchar x,uchar y)
{
  uchar j,b;
  ushort addr;
  if (c==',') {PutChar_lt(0x95,x,y+16); goto l_PutChar_big0;}; //  
  if (c=='-') {PutChar_lt(0x96,x,y+10); goto l_PutChar_big0;}; // -
  if (c==' ') {PutChar_lt(' ',x,y+10); goto l_PutChar_big0;}; //
  for (j=0;j<24;j++)
  {
    addr=vLCD_GH+(y+j)*vLCD_GA+x;
    b= char_big[c][j*2];
    WR_dt(addr&0xFF); WR_dt(addr>>8); WR_cmd(0x24);
    WR_dt(b); WR_cmd(0xc0);
    b= char_big[c][j*2+1];	
    WR_dt(b); WR_cmd(0xc4);
  }
l_PutChar_big0: ;
}


//----------------------------------------------------------------------------------

// 1  16x16      X  Y
// x = 0...29; y = 0-127 (c c "")
//        
void PutChar_img(uchar c,uchar x,uchar y)
{
  uchar j,b;
  ushort addr;
  for (j=0;j<16;j++)
  {
    addr=vLCD_GH+(y+j)*vLCD_GA+x;
    b= char_img[c][j*2];
    WR_dt(addr&0xFF); WR_dt(addr>>8); WR_cmd(0x24);
    WR_dt(b); WR_cmd(0xc0);
    b= char_img[c][j*2+1];
    WR_dt(b); WR_cmd(0xc4);
  }
;
}
//----------------------------------------------------------------------------------

void write_str(const char *s,uchar x,uchar y)
{
  uchar xt;
  xt=x;
  while (*s != 0)
  { PutChar_lt((*s++),xt++,y);};
}
;
//----------------------------------------------------------------------------------

void write_str_f(char __flash *s,uchar x,uchar y)
{
  uchar xt;
  xt=x;
  while (*s != 0)
  { PutChar_lt((*s++),xt,y);
    xt++;
    if (xt>30) break;
  };
}

